/* com.cintegrity.Lib.Collection.TestSortedSet.p */

define variable lob_MySet as com.cintegrity.Lib.Collection.SortedSet no-undo.
define variable lob_CurrentLine as com.cintegrity.Lib.ABL.ABLXrefLine no-undo.
define variable lob_OtherLine as com.cintegrity.Lib.ABL.ABLXrefLine no-undo.
define variable lob_OldLine as com.cintegrity.Lib.ABL.ABLXrefLine no-undo.
define variable lob_DummyLine as com.cintegrity.Lib.ABL.ABLXrefLine no-undo.
define variable lch_InputFileName as character no-undo initial "com/cintegrity/Lib/Collection/SortedSet.xrf".
define variable lch_InputLine as character no-undo.
define variable lin_Element as integer no-undo.
define variable lin_LineNumber as integer no-undo.
define variable lch_ObjectIdentifier as character no-undo.
define variable llg_IsOK as logical no-undo.
define stream st_Input.

if search( lch_InputFileName ) ne ?
then lch_InputFileName = search( lch_InputFileName ).
else do:
  message "Could not find test input file " + lch_InputFileName + " - aborting" view-as alert-box.
  return.
end.

lob_MySet = new com.cintegrity.Lib.Collection.SortedSet().

input stream st_Input from value( lch_InputFileName ).
repeat:
  import stream st_Input unformatted lch_InputLine.
  lch_ObjectIdentifier = "".
  if num-entries( lch_InputLine, " " ) ge 5
  then do lin_Element = 5 to num-entries( lch_InputLine, " " ).
    if lin_Element = 5
    then lch_ObjectIdentifier = entry( lin_Element, lch_InputLine, " " ).
    else lch_ObjectIdentifier = lch_ObjectIdentifier + " " + entry( lin_Element, lch_InputLine, " " ).
  end.
  lob_CurrentLine = new com.cintegrity.Lib.ABL.ABLXrefLine(
      entry( 1, lch_InputLine, " " ),
      entry( 2, lch_InputLine, " " ),
      integer( entry( 3, lch_InputLine, " " ) ),
      entry( 4, lch_InputLine, " " ),
      lch_ObjectIdentifier
      ).
  llg_IsOK = lob_MySet:addElement( lob_CurrentLine ).
  if not llg_IsOK
  then do:
    message "Unexpected error creating initial sorted set" view-as alert-box.
    return.
  end.
end.

message "Number of lines in Sorted Set = " + string(lob_MySet:size()) view-as alert-box.

message "Is set empty? " + string(lob_MySet:isEmpty()) view-as alert-box.

message "Set contains last line read = " + string(lob_MySet:containsElement( lob_CurrentLine )) view-as alert-box.

llg_IsOK = lob_MySet:removeElement( lob_CurrentLine ).
if not llg_IsOK
then do:
  message "Unexpected error on remove of last line" view-as alert-box.
  return.
end.

message "After removing last element, number of lines = " + string(lob_MySet:size()) view-as alert-box.

message "Positioned at end, then 'has next' = " + string(lob_MySet:hasNextElement()) + " and 'has prev' = " + string(lob_MySet:hasPrevElement()) view-as alert-box.

lob_OtherLine = cast(lob_MySet:GetFirst(), "com.cintegrity.Lib.ABL.ABLXrefLine").
message "Positioned at the beginning, then 'has next' = " + string(lob_MySet:hasNextElement())  " and 'has prev' = " + string(lob_MySet:hasPrevElement()) view-as alert-box.

do lin_LineNumber = 1 to lob_MySet:size():
  if lob_OtherLine:getReferenceType() = "REFERENCE"
  then leave.
  else lob_OtherLine = cast(lob_MySet:nextElement(), "com.cintegrity.Lib.ABL.ABLXrefLine").
  if not valid-object( lob_OtherLine ) then leave.
end.

if valid-object( lob_OtherLine )
then message "First line with reference type = 'REFERENCE' is line " + string( lin_LineNumber ) view-as alert-box.
else message "No line has reference type = 'REFERENCE'" view-as alert-box.

lob_OtherLine = cast(lob_MySet:prevElement(), "com.cintegrity.Lib.ABL.ABLXrefLine" ).
message "Reference type on prior line is " + lob_OtherLine:getReferenceType() view-as alert-box.

lob_DummyLine = new com.cintegrity.Lib.ABL.ABLXrefLine(
    "DUMMY",
    "DUMMY",
    1,
    "DUMMY",
    "DUMMY"
    ).
llg_IsOK = lob_MySet:addElement( lob_DummyLine ).
if not llg_IsOK
then do:
  message "Unexpected error adding dummy line to end" view-as alert-box.
  return.
end.
message "Line with object identifier = " + lob_DummyLine:getObjectIdentifier() + " added as last line" view-as alert-box.

lob_OldLine = cast(lob_MySet:setElement( lob_CurrentLine ), "com.cintegrity.Lib.ABL.ABLXrefLine" ).
message "Last line replaced with original last line" view-as alert-box.
message "Replaced line had object identifier = " + lob_OldLine:getObjectIdentifier() view-as alert-box.

lob_OtherLine = cast( lob_MySet:getLast(), "com.cintegrity.Lib.ABL.ABLXrefLine" ).
message "Last Line now has object identifier = " + lob_OtherLine:getObjectIdentifier() view-as alert-box.

lob_MySet:clearAll().
message "After clearing all elements, number of lines = " + string(lob_MySet:size()) view-as alert-box.

delete object lob_MySet.
delete object lob_CurrentLine.
if valid-object( lob_OtherLine )
then delete object lob_OtherLine.
delete object lob_DummyLine.
assign
    lob_MySet = ?
    lob_OtherLine = ?
    lob_CurrentLine = ?
    lob_DummyLine = ?
    .
